import jenkins.model.*
import hudson.tools.*
import jenkins.plugins.nodejs.tools.*

def inst = Jenkins.getInstance()

{% if item.name == "maven" %}
def desc = Jenkins.instance.getExtensionList(hudson.tasks.Maven.DescriptorImpl.class)[0];
def installations = (desc.installations as List);

mavenInstall = installations.find {
    install -> install.name.equals("{{ item.version }}")
}

if (mavenInstall == null) {
    installations.add(new hudson.tasks.Maven.MavenInstallation("{{ item.version }}", "{{ user_vars.install.home }}/.sdkman/candidates/maven/{{ item.version }}", []));
    desc.installations=installations
    desc.save()
}

{% endif %}

{% if item.name == "java" %}

def desc = Jenkins.instance.getDescriptorByName("hudson.model.JDK");
def installations = [];

jdkInstall = installations.find {
    install -> install.name.equals("{{ item.version }}")
}

if (jdkInstall == null) {
    installations.add(new hudson.model.JDK("{{ item.version }}", "{{ user_vars.install.home }}/.sdkman/candidates/java/{{ item.version }}"));
    desc.setInstallations((hudson.model.JDK[])installations)
    desc.save()
}

{% endif %}

{% if item.name == "nodejs" %}
def desc = inst.getDescriptor("jenkins.plugins.nodejs.tools.NodeJSInstallation")
def installations = (desc.installations as List)

nodeInstall = installations.find {
   install -> install.name.equals("{{ item.version }}")
}

if (nodeInstall == null) {
    installations.add(new NodeJSInstallation("{{ item.version }}", "{{ path_tools }}/node-v{{ item.version }}/", null))
    desc.setInstallations((jenkins.plugins.nodejs.tools.NodeJSInstallation[])installations)
    desc.save()
}

{% endif %}